require 'thor'
require 'slog'

require_relative 'app'
require_relative 'helpers'
require_relative 'metadata'


module DBum

  # DBum's entrypoint.
  class Main < Thor
    include DBum::Helpers


    desc 'version', 'Echo the application version'
    def version
      puts VERSION
      return nil
    end


    desc 'art', 'View the application art'
    def art
      puts
      puts ART
      puts
      return nil
    end


    desc 'server', 'Start the application Web server'
    option :port, \
      type: :numeric,
      aliases: %w[ -p ],
      desc: 'Set Sinatra port',
      default: 4567
    option :environment, \
      type: :string,
      aliases: %w[ -e ],
      desc: 'Set Sinatra environment',
      default: 'development'
    option :bind, \
      type: :string,
      aliases: %w[ -b ],
      desc: 'Set Sinatra interface',
      default: '0.0.0.0'
    option :database, \
      type: :string,
      aliases: %w[ -t ],
      desc: 'Location of application database',
      default: 'um.db'
    option :debug, \
      type: :boolean,
      aliases: %w[ -d ],
      desc: 'Enable debugging output',
      default: false
    def server
      App.config! options
      App.run!
      at_exit do
        App.close!
      end
    end

  end
end